// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from metro_benchmark_msgs:msg/ComputeTime.idl
// generated code does not contain a copyright notice

#ifndef METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__STRUCT_H_
#define METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"
// Member 'duration'
#include "builtin_interfaces/msg/detail/duration__struct.h"
// Member 'id'
// Member 'parent_id'
#include "rosidl_runtime_c/string.h"

/// Struct defined in msg/ComputeTime in the package metro_benchmark_msgs.
/**
  * Interface for recording the amount of time some compute function took
  * In the header, the frame_id should be the name of the function/task i.e. ComputePathToPose
  *                and the stamp should be the *completion* time
 */
typedef struct metro_benchmark_msgs__msg__ComputeTime
{
  std_msgs__msg__Header header;
  /// The duration should be populated with the total amount of time the function took.
  /// This implies that the function started at header.stamp - duration
  builtin_interfaces__msg__Duration duration;
  /// The id (optional) is for providing a unique identifier for the instance of the function running
  /// e.g. ComputePathToPose0
  rosidl_runtime_c__String id;
  /// The parent id (optional) allows you to create nested benchmarked functions
  rosidl_runtime_c__String parent_id;
} metro_benchmark_msgs__msg__ComputeTime;

// Struct for a sequence of metro_benchmark_msgs__msg__ComputeTime.
typedef struct metro_benchmark_msgs__msg__ComputeTime__Sequence
{
  metro_benchmark_msgs__msg__ComputeTime * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} metro_benchmark_msgs__msg__ComputeTime__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // METRO_BENCHMARK_MSGS__MSG__DETAIL__COMPUTE_TIME__STRUCT_H_
